#%define snap	20040801
%define module	HTML-Embperl
%define version	2.0rc1
#%define release	0.%{snap}.1mdk
%define release	0.1mdk

%{expand:%%define perl_version %(rpm -q perl --queryformat '%%{epoch}:' | grep -v none)%(rpm -q perl --queryformat '%%{version}')}
%{expand:%%define modperl_version %(rpm -q apache2-mod_perl --queryformat '%%{epoch}:' | grep -v none)%(rpm -q apache2-mod_perl --queryformat '%%{version}')}

#New ADVX macros
%define ADVXdir %{_datadir}/ADVX
%{expand:%(cat %{ADVXdir}/ADVX-build)}
%{expand:%%global ap_version %(%{apxs} -q ap_version)}

%define mod_conf 76_Embperl.conf

Summary:	Embperl is a framework for building web sites with Perl.
Name:		apache2-%{module}
Version:	%{version}
Release:	%{release}
License:	GPL
Group:		System/Servers
#Source0:	Embperl-%{version}-%{snap}.tar.bz2
Source0:	Embperl-%{version}.tar.bz2
Source1:	%{mod_conf}.bz2
Patch:		Embperl-2.09b-fix-CVS.patch.bz2
URL:		http://perl.apache.org/embperl/
Requires:	perl = %{perl_version}
Prereq:         %{ap_name} = %{ap_version}
Prereq:         %{ap_name}-conf
Requires:	%{ap_name}-mod_perl = %{modperl_version}
Requires:	perl = %{perl_version}
BuildRequires:	ADVX-build >= 9.2
BuildRequires:	%{ap_name} = %{ap_version}
BuildRequires:	%{ap_name}-modules = %{ap_version}
BuildRequires:	%{ap_name}-mod_perl = %{modperl_version}
#BuildRequires:	perl-File-Spec 
BuildRequires:	libxml2-devel
BuildRequires:	libxslt1-devel
BuildRequires:	perl-Apache-Session
BuildRequires:	perl-Apache-SessionX 
BuildRequires:	perl-ExtUtils-XSBuilder
BuildRequires:	perl-HTML-Parser 
BuildRequires:	perl-Parse-RecDescent
BuildRequires:	perl-Tie-IxHash
BuildRequires:	perl-libwww-perl
BuildRequires:	perl-devel
BuildRoot:	%{_tmppath}/%{name}-buildroot/

%description
Embperl is a framework for building websites with Perl.

For the beginner it's an easy to setup and use way of embedding Perl code in
HTML pages. It delivers several features that ease the task of creating a
ebsites, including dynamic tables, formfield-processing,
escaping/unescaping, session handling, caching and more.

If your demands grow it gives you the power to make your Website
object-oriented and build it out of small reusable components. If you don't
like the idea of mixing up all your layout and code then Embperl also
supports separating it in different objects (e.g. creating an MVC
application). Of course Embperl doesn't tie you to HTML - it allows
components to be from different source formats (e.g. HTML, WML, XML, POD,
...) and if necessary transforms them (for example via XSLT) to other output
formats. This is achieved by dividing the output generation into small
steps, where each is processed by a plugable provider. Advanced users can
create their own syntax definitions (for example tag libraries) and extend
Embperl by writing their own providers and much more...

Embperl is a server-side tool, which means that it's browser-independent. It
can run in various ways: under mod_perl, as a CGI script, or offline.

%prep

#%%setup -q -n Embperl-%{version}-%{snap}
%setup -q -n Embperl-%{version}
#cvs -d:pserver:anoncvs@cvs.apache.org:/home/cvspublic login
#cvs -d:pserver:anoncvs@cvs.apache.org:/home/cvspublic co embperl
#tar cvjf $RPM_SOURCE_DIR/embperl.tar.bz2 embperl

# fix strange perms
find . -type d -perm 0700 -exec chmod 755 {} \;
find . -type f -perm 0555 -exec chmod 755 {} \;
find . -type f -perm 0444 -exec chmod 644 {} \;

rm -f eg/x/config.htm
%patch -p1
perl -pi -e "s/\&lt;/\</;" eg/x/loop.htm

cat << EOF > eg/.htaccess
<Files ~ (\.htm)>
SetHandler perl-script
PerlResponseHandler Embperl
</Files>
Options +Indexes
EOF

find -type d|grep CVS|xargs rm -rf
find -type f|grep cvsignore|xargs rm -f

%build
# (oe) pull in the apr and apu headers where ever they may be
export APR_HEADERS="`apr-config --includes`"
export APU_HEADERS="`apu-config --includes`"
perl -pi -e "s|-I\\\$EPPATH \\\$i|-I\\\$EPPATH \\\$i $APR_HEADERS $APU_HEADERS|g" Makefile.PL

perl -pi -e "s/action_module/actions_module/;" Makefile.PL
perl xsbuilder/source_scan.pl
perl xsbuilder/xs_generate.pl

cat << EOF | perl Makefile.PL INSTALLDIRS=vendor INC="-I%{ap_includedir} -I%{ap_includedir}/regex -I%{ap_includedir}/os/unix $APR_HEADERS $APU_HEADERS -I%{_includedir}/libxml2 -I./xs"
y
%{ap_includedir}
y
%{_sbindir}/%{ap_progname}
%{ap_extralibs}
%{ap_libexecdir}
.
EOF
make

# make test does not succeed even with older versions
#make test

%install
[ "%{buildroot}" != "/" ] && rm -rf %{buildroot}

eval `perl '-V:installarchlib'`
mkdir -p %{buildroot}/$installarchlib
%makeinstall_std

%__os_install_post
find %{buildroot}%{_prefix} -type f -print | sed "s@^%{buildroot}@@g" | grep -v perllocal.pod > %{module}-%{version}-filelist

%ADVXinstconf %{SOURCE1} %{mod_conf}
%ADVXinstdoc %{name}-%{version}

rm -rf test/tmp/* 
rm -rf blib
mkdir -p blib/arch
pushd blib/arch
eval `perl '-V:vendorarch'`
ln -s ../../../../../..$vendorarch/auto/ .
popd

cd test
#chmod 755 tmp
find -type f|xargs perl -pi -e \
	"s|$RPM_BUILD_DIR/embperl|%{_docdir}/%{name}-%{version}|g;"
perl -pi -e 's/\015//;' conf/config.pl
cd ..
rm -f %{buildroot}$vendorarch/auto/Embperl/*.bs

%post
%ADVXpost

%postun
%ADVXpost

%clean 
[ "%{buildroot}" != "/" ] && rm -rf %{buildroot}

%files
%defattr(-,root,root)
%doc MANIFEST READM* eg test.pl test *.pod TODO blib
%config(noreplace) %{ap_confd}/%{mod_conf}
%{_bindir}/*
%{perl_vendorlib}/*
%{_mandir}/*/*
%{ap_webdoc}/*

%changelog
* Wed Aug 25 2004 Oden Eriksson <oeriksson@mandrakesoft.com> 2.0rc1-0.1mdk
- 2.0rc1

* Mon Aug 02 2004 Oden Eriksson <oeriksson@mandrakesoft.com> 2.0b12-0.20040801.1mdk
- use a recent snap (20040801)

* Mon Aug 02 2004 Oden Eriksson <oeriksson@mandrakesoft.com> 2.0b11-1mdk
- 2.0b11
- remove redundant provides
- pull in the apr and apu headers where ever they may be

* Wed Apr 07 2004 Michael Scherer <misc@mandrake.org> 2.0b9-0.20030308.8mdk 
- rebuild for new perl

* Wed Jan 21 2004 Pixel <pixel@mandrakesoft.com> 2.0b9-0.20030308.7mdk
- added epoch in versions
- removed explicit lib dependencies 

* Wed Jan 21 2004 Pixel <pixel@mandrakesoft.com> 2.0b9-0.20030308.6mdk
- rebuild for new perl

* Thu Aug 14 2003 Per yvind Karlsen <peroyvind@linux-mandrake.com> 2.0b9-0.20030308.5mdk
- rebuild for new perl
- use %%makeinstall_std macro

* Tue Jul 29 2003 Oden Eriksson <oden.eriksson@kvikkjokk.net> 2.0b9-0.20030308.4mdk
- rebuilt for apache v2.0.47
- fix buildrequires on perl-devel (oops!)

* Sat May 31 2003 Oden Eriksson <oden.eriksson@kvikkjokk.net> 2.0b9-0.20030308.3mdk
- rebuilt for apache v2.0.46
- buildprereq ADVX-build >= 9.2
- fix buildrequires
- misc spec file fixes

* Mon Mar 17 2003 Jean-Michel Dault <jmdault@mandrakesoft.com> 2.0b9-0.20030308.2mdk
- fix description

* Sat Mar  8 2003 Jean-Michel Dault <jmdault@mandrakesoft.com> 2.0b9-0.20030308.1mdk
- initial contribs release
